(function ( $ ) {
	
	$.fn.buttonset = function( options ) {
	
		var _buttonset = this; // cache this for easy scoping later
		var _selected = {}; // the last selected button
		var _disabled = false;
		
		var settings = $.extend({
		// these are the defaults
			width: "32px",
			height: "32px",
			background:"button.png"
		}, options );
		
		//
		// handle hover event
		// change the position of the background to show over state
		// if the object raising the event is the current object, ignore event
		$(this).hover (
			function() {
				if($(this)[0] === _selected[0]) return;
				$(this).css({ backgroundPosition: "-32px" });
			}, function() {
				if($(this)[0] === _selected[0]) return;
				$(this).css({ backgroundPosition: "0px"	});
			}
		);
		
		//
		// set _selected to the object that raises the click event
		// change the background position to show the selected/disabled state
		// set all other buttons to their normal state
		$(this).click (
		
			function() {			
				var selectedButton = $(this);
				_buttonset.each(function() {					
					if($(this)[0] === selectedButton[0]){
						_selected = $(this);
  						$(this).css({
							cursor: "default",
							backgroundPosition: "-64px"				
						});
					}else{
						$(this).css({
							cursor: "pointer",
							backgroundPosition: "0px"				
						});
					}
				});
				
				options.onButtonSelected($(selectedButton).val());
			}
		);
						
		return this.css({
			background: "transparent",
			border: "none",	
			backgroundRepeat: "no-repeat",
			cursor: "pointer",
			width: settings.width,
			height: settings.height,
			background: "url(" + settings.background + ")"
		});		
		
	};
}( jQuery ));